#
# This file is automatically generated from the file bats_sfp_test_2tests.def
#
# To regenerate this file please redirect output from the commend:
# ./generate_tests.sh bats_sfp_test_2tests.def
# or run:
# make create_results

load bats_sfp_test_config
load bats_sfp_test_helpers

@test "hist_sfp_run none file exists" {
    helper_hist_sfp_run_test \
        none \
        none \
        hist_sfp_run_none_file_exists.txt
}

@test "hist_sfp_run one file exists" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_5sfp.bin \
        none \
        hist_sfp_run_one_file_exists.txt
}

@test "hist_sfp_run both files ok, both are the same" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_5sfp.bin \
        lifetime_sfp_stats_ok_5sfp_b.bin \
        hist_sfp_run_both_files_ok_both_are_the_same.txt
}

@test "hist_sfp_run both files ok, both are the same file" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_5sfp.bin \
        lifetime_sfp_stats_ok_5sfp.bin \
        hist_sfp_run_both_files_ok_both_are_the_same_file.txt
}

@test "hist_sfp_run both files ok, old and old" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_5sfp_old.bin \
        lifetime_sfp_stats_ok_5sfp_old.bin \
        hist_sfp_run_both_files_ok_old_and_old.txt
}

@test "hist_sfp_run both files ok, old and new" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_5sfp_old.bin \
        lifetime_sfp_stats_ok_5sfp.bin \
        hist_sfp_run_both_files_ok_old_and_new.txt
}

@test "hist_sfp_run both files ok, new and old" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_5sfp.bin \
        lifetime_sfp_stats_ok_5sfp_old.bin \
        hist_sfp_run_both_files_ok_new_and_old.txt
}

@test "hist_sfp_run both files ok, 5sfp and 2sfp" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_5sfp.bin \
        lifetime_sfp_stats_ok_2sfp_old.bin \
        hist_sfp_run_both_files_ok_5sfp_and_2sfp.txt
}

@test "hist_sfp_run both files ok, the same file with 2sfp" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_2sfp_old.bin \
        lifetime_sfp_stats_ok_2sfp_old.bin \
        hist_sfp_run_both_files_ok_the_same_file_with_2sfp.txt
}

# should ignore the one with the wrong CRC
@test "hist_sfp_run both files ok, 5sfp with wrong main crc and 5sfp" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_5sfp_wrong_main_crc.bin \
        lifetime_sfp_stats_ok_5sfp.bin \
        hist_sfp_run_both_files_ok_5sfp_with_wrong_main_crc_and_5sfp.txt
}

# should ignore the one with the wrong CRC
@test "hist_sfp_run both files ok, 5sfp and 5sfp with wrong main crc" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_5sfp.bin \
        lifetime_sfp_stats_ok_5sfp_wrong_main_crc.bin \
        hist_sfp_run_both_files_ok_5sfp_and_5sfp_with_wrong_main_crc.txt
}

# should ignore the one with the wrong CRC
@test "hist_sfp_run both files ok, 2sfp and 5sfp with wrong main crc" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_2sfp_old.bin \
        lifetime_sfp_stats_ok_5sfp_wrong_main_crc.bin \
        hist_sfp_run_both_files_ok_2sfp_and_5sfp_with_wrong_main_crc.txt
}

# should ignore the one with the wrong CRC
@test "hist_sfp_run both files ok, 2sfp with wrong main crc and 5sfp" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_2sfp_old_wrong_main_crc.bin \
        lifetime_sfp_stats_ok_5sfp.bin \
        hist_sfp_run_both_files_ok_2sfp_with_wrong_main_crc_and_5sfp.txt
}

# should combine database in a was to take all from 5sfp, since there are newer
@test "hist_sfp_run both files ok, 2sfp and 5sfp both with wrong main crc" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_2sfp_old_wrong_main_crc.bin \
        lifetime_sfp_stats_ok_5sfp_wrong_main_crc.bin \
        hist_sfp_run_both_files_ok_2sfp_and_5sfp_both_with_wrong_main_crc.txt
}

# should ignore the one with the wrong CRC
@test "hist_sfp_run both files ok, 2sfp and 5sfp with wrong main end crc" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_5sfp_wrong_main_end_crc.bin \
        lifetime_sfp_stats_ok_2sfp_old.bin \
        hist_sfp_run_both_files_ok_2sfp_and_5sfp_with_wrong_main_end_crc.txt
}

# should ignore SFP entry with the wrong CRC, entry 0 should be empty
@test "hist_sfp_run both files ok, two 5sfp both with wrong entry 0" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_5sfp_wrong_main_crcs_wrong_crc_sfp0.bin \
        lifetime_sfp_stats_ok_5sfp_wrong_main_crcs_wrong_crc_sfp0.bin \
        hist_sfp_run_both_files_ok_two_5sfp_both_with_wrong_entry_0.txt
}

# should ignore SFP entry 0 from 5sfp with the wrong CRC, entry 0 should be from 2sfp
@test "hist_sfp_run both files ok, 2sfp with wrong main crc and 5sfp with wrong entry 0" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_2sfp_old_wrong_main_crc.bin \
        lifetime_sfp_stats_ok_5sfp_wrong_main_crcs_wrong_crc_sfp0.bin \
        hist_sfp_run_both_files_ok_2sfp_with_wrong_main_crc_and_5sfp_with_wrong_entry_0.txt
}

# should take 2 old sfps
@test "hist_sfp_run both files ok, 5sfp truncated, 2sfp old" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_5sfp_trunc.bin \
        lifetime_sfp_stats_ok_2sfp_old.bin \
        hist_sfp_run_both_files_ok_5sfp_truncated_2sfp_old.txt
}

# should combine database in a was to take all from 5sfp, since there are newer
@test "hist_sfp_run both files ok, 5sfp truncated, 2sfp truncated" {
    helper_hist_sfp_run_test \
        lifetime_sfp_stats_ok_5sfp_trunc.bin \
        lifetime_sfp_stats_ok_2sfp_old_trunc.bin \
        hist_sfp_run_both_files_ok_5sfp_truncated_2sfp_truncated.txt
}

