#!/bin/bash

shopt -s extglob
BATS_TEST_DEFINITIONS=$1

echo "#"
echo "# This file is automatically generated from the file $BATS_TEST_DEFINITIONS"
echo "#"
echo "# To regenerate this file please redirect output from the commend:"
echo "# ./generate_tests.sh $BATS_TEST_DEFINITIONS"
echo "# or run:"
echo "# make create_results"
echo ""
echo "load bats_sfp_test_config"
echo "load bats_sfp_test_helpers"
echo ""

while IFS=";" read test_name file1 file2; do
    # keep lines starting with "#" or ""as they are
    if [ "${test_name:0:1}" = "#" ] || [ "${test_name:0:1}" = "" ]; then
	# ignore "##"
	if [ "${test_name:0:2}" = "##" ]; then continue; fi
	echo "$test_name$file1$file2"
	continue;
    fi
    file1="${file1##*( )}"
    file2="${file2##*( )}"
    result_file="${test_name// /_}.txt"
    result_file="${result_file//,}"
    echo "@test \"$test_name\" {"
    echo "    helper_hist_sfp_run_test \\"
    echo "        $file1 \\"
    echo "        $file2 \\"
    echo "        $result_file"
    echo "}"
    echo ""
done < $BATS_TEST_DEFINITIONS
exit
