#ifndef __LIBWR_HIST_SHMEM_H__
#define __LIBWR_HIST_SHMEM_H__

#include <libwr/hist.h>

/* This is the overall structure stored in shared memory */
#define HIST_SHMEM_VERSION 1 /* Version 1 first version */

struct hist_shmem_data {
	struct wrs_hist_up_nand hist_up_nand;
	struct wrs_hist_up_spi hist_up_spi;
	struct wrs_hist_sfp_nand hist_sfp_nand;
	/* live histogram, hours of particular temperatures, 512 bytes */
	uint16_t temp[WRS_HIST_TEMP_SENSORS_N][WRS_HIST_TEMP_ENTRIES];
	/* Histogram of SFPs temperatures */
	//struct wrs_hist_sfp_temp hist_sfp_temp[WRS_HIST_MAX_SFPS];
};

struct hist_description {
	int8_t from;
	int8_t to;
	char *desc; /* description */
};

extern struct hist_description h_descr[WRS_HIST_TEMP_ENTRIES];

#ifdef HIST_SHMEM_STRUCTURES
struct hist_description h_descr[WRS_HIST_TEMP_ENTRIES] = {
	[0] =  {-127, -20, "<-20..-20"}, /* d = 108 */
	[1] =  {-19, -10, "-19..-10"}, /* d = 10 */
	[2] =  {-9, 0, "-9..0"}, /* d = 10 */
	[3] =  {1, 5, "1..5"}, /* d = 5 */
	[4] =  {6, 7, "6..7"}, /* d = 2 */
	[5] =  {8, 9, "8..9"}, /* d = 2 */
	[6] =  {10, 11, "10..11"}, /* d = 2 */
	[7] =  {12, 13, "12..13"}, /* d = 2 */
	[8] =  {14, 15, "14..15"}, /* d = 2 */
	[9] =  {16, 17, "16..17"}, /* d = 2 */
	[10] = {18, 19, "18..19"}, /* d = 2 */
	[11] = {20, 21, "20..21"}, /* d = 2 */
	[12] = {22, 23, "22..23"}, /* d = 2 */
	[13] = {24, 25, "24..25"}, /* d = 2 */
	[14] = {26, 27, "26..27"}, /* d = 2 */
	[15] = {28, 29, "28..29"}, /* d = 2 */
	[16] = {30, 30, "30..30"}, /* d = 1 */
	[17] = {31, 31, "31..31"}, /* d = 1 */
	[18] = {32, 32, "32..32"}, /* d = 1 */
	[19] = {33, 33, "33..33"}, /* d = 1 */
	[20] = {34, 34, "34..34"}, /* d = 1 */
	[21] = {35, 35, "35..35"}, /* d = 1 */
	[22] = {36, 36, "36..36"}, /* d = 1 */
	[23] = {37, 37, "37..37"}, /* d = 1 */
	[24] = {38, 38, "38..38"}, /* d = 1 */
	[25] = {39, 39, "39..39"}, /* d = 1 */
	[26] = {40, 40, "40..40"}, /* d = 1 */
	[27] = {41, 41, "41..41"}, /* d = 1 */
	[28] = {42, 42, "42..42"}, /* d = 1 */
	[29] = {43, 43, "43..43"}, /* d = 1 */
	[30] = {44, 44, "44..44"}, /* d = 1 */
	[31] = {45, 45, "45..45"}, /* d = 1 */
	[32] = {46, 46, "46..46"}, /* d = 1 */
	[33] = {47, 47, "47..47"}, /* d = 1 */
	[34] = {48, 48, "48..48"}, /* d = 1 */
	[35] = {49, 49, "49..49"}, /* d = 1 */
	[36] = {50, 50, "50..50"}, /* d = 1 */
	[37] = {51, 51, "51..51"}, /* d = 1 */
	[38] = {52, 52, "52..52"}, /* d = 1 */
	[39] = {53, 53, "53..53"}, /* d = 1 */
	[40] = {54, 54, "54..54"}, /* d = 1 */
	[41] = {55, 55, "55..55"}, /* d = 1 */
	[42] = {56, 56, "56..56"}, /* d = 1 */
	[43] = {57, 57, "57..57"}, /* d = 1 */
	[44] = {58, 58, "58..58"}, /* d = 1 */
	[45] = {59, 59, "59..59"}, /* d = 1 */
	[46] = {60, 60, "60..60"}, /* d = 1 */
	[47] = {61, 61, "61..61"}, /* d = 1 */
	[48] = {62, 63, "62..63"}, /* d = 2 */
	[49] = {64, 65, "64..65"}, /* d = 2 */
	[50] = {66, 67, "66..67"}, /* d = 2 */
	[51] = {68, 69, "68..69"}, /* d = 2 */
	[52] = {70, 71, "70..71"}, /* d = 2 */
	[53] = {72, 73, "72..73"}, /* d = 2 */
	[54] = {74, 75, "74..75"}, /* d = 2 */
	[55] = {76, 77, "76..77"}, /* d = 2 */
	[56] = {78, 79, "78..79"}, /* d = 2 */
	[57] = {80, 81, "80..81"}, /* d = 2 */
	[58] = {82, 83, "82..83"}, /* d = 2 */
	[59] = {84, 85, "84..85"}, /* d = 2 */
	[60] = {86, 90, "86..90"}, /* d = 5 */
	[61] = {91, 95, "91..95"}, /* d = 5 */
	[62] = {96, 100, "96..100"}, /* d = 5 */
	[63] = {101, 128, "101..>100"}, /* d = 28 */
};
#endif

#endif /*  __LIBWR_HIST_SHMEM_H__ */

